#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "ServiceProvider.h"

int main (int argc, const char * argv[]) {
  
  //create the default autorelease pool
  NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
  
  //Create our service provider object and register it
  ServiceProvider* provider = [[ServiceProvider alloc] init];
  NSRegisterServicesProvider(provider, @"UnmountService");
  
  //Start our run loop. This will continue to run in the background and handle received events.
  @try
  {
    [[NSRunLoop currentRunLoop] configureAsServer];
    [[NSRunLoop currentRunLoop] run];
  }
  @catch(NSException* e)
  {
    NSLog(@"%@", e);
  }
  
  //If the run loop stops, clean up and exit
  [provider release];
  [pool release];
  exit(0);
  return 0;
}
